;         Programa que soma 2 numeros de 16 bits e depois os mostra, testando
;	na leitura das entradas uma condio de fim. Se condio de fim no atingida,
;	incrementa o valor da soma e exibe o novo valor nas saidas, ficando neste
;	lao at ocorrer a condio de parada
;
;               n1h n1l
;           +   n2h n2l
;              --------
;             cy rh  rl
;
.code
add16:	lda	n1l		; soma partes baixas
		add	n2l
		sta	rl
		jc	carryl,R	; se deu vai um, propaga para parte alta
		jmp	cont1		; seno, continua
carryl:	lda	rh
		add	#01h
		sta	rh
cont1:	lda 	n1h		; adiciona parte alta do primeiro ao resultado parcial
		add 	rh
		sta	rh		; guarda resultado parcial
		jsr	carryh	; se j deu vai um, guarda informao em varivel
cont2:	lda	n2h		; adiciona parte alta do segundo ao resultado parcial
		add	rh
		sta	rh
		jsr	carryh	; se deu vai um, guarda informao em varivel

exibe:	lda	rh
		sta	0FFH		; escreve em saidah
		lda	rl                        
		sta	0FEH		; escreve em saidal
         
		lda	0FDH		; aqui vai ler as chaves
		sta	0FDH
		jz	fim,R       ; quando tiver 0 nas chaves termina execucao

		lda	rl		; seno; incrementa parte baixa
		add	#1
		sta	rl
		jc	addh		; se vai-um, salta para tratar
		jmp	exibe,R	; seno, reexibe
addh:		lda	rh		; se vai-um, incrementa parte alta
		add	#1
		sta	rh	
         	jsr	carryh
		jmp  exibe,R
   
fim:		hlt

;	Subrotina que testa se deve setar o bit menos
;	significativo de cy para indicar que houve vai-um 
;	na operao de soma em 16 bits
;
carryh:	jc	setacy	; se deu vai-um, seta bit menos significativo de cy
		rts			; seno,nada faz
setacy:	lda	#01h
		sta	cy
		rts

.endcode

.data

n1h:		db	#3FH
n1l:		db	#84H
n2h:		db	#3EH
n2l:		db	#0CAH
rh:		db	#00H
rl:		db	#00H
cy:		db	#00H

.enddata
